Index: GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/media/maple/leaves/sampleMapleLeaves.cfg
===================================================================
--- GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/media/maple/leaves/sampleMapleLeaves.cfg	(revision 861)
+++ GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/media/maple/leaves/sampleMapleLeaves.cfg	(revision 900)
@@ -5,5 +5,5 @@
 Entity Distribution Generation							no
 Entity Distribution Splitted							yes
-Entity Distribution Merged							yes
+Entity Distribution Merged							no
 Entity Distribution XML Name							mapleLeavesEntityDistribution.xml
 Entity Distribution Splitted Mesh Name						mapleLeavesEntityDistributionSplitted.mesh
@@ -21,6 +21,6 @@
 Entity Clusters Grouped Clusters						yes
 Entity Clusters Splitted Clusters						no
-Entity Clusters Alpha								2
-Entity Clusters MaxClusters							128
+Entity Clusters Alpha								25
+Entity Clusters MaxClusters							75
 Entity Clusters NumIterations							3
 Entity Clusters Folder								../../media/maple/leaves/
@@ -33,19 +33,21 @@
 
 Billboard Cloud Generation							yes
-Billboard Cloud Merged Billboards						yes
-Billboard Cloud Grouped Billboards						yes
-Billboard Cloud Splitted Billboards						yes
-Billboard Cloud Groups								1
 Billboard Cloud Folder								../../media/maple/leaves/
 
-Billboard Cloud Merged XML Name							mapleLeavesBillboardCloudMerged.xml
-Billboard Cloud Merged Mesh Name						mapleLeavesBillboardCloudMerged.mesh
-Billboard Cloud Merged Material Name						mapleLeavesBillboardCloudMergedMaterial
-Billboard Cloud Merged Texture Unit 0 Name					mapleLeavesBillboardTexture
+Billboard Cloud Splitted Billboards						yes
+Billboard Cloud Grouped Diffuse Color Billboards				yes
+Billboard Cloud Grouped Diffuse Color Groups					1
+Billboard Cloud Grouped Indirect Texturing Billboards				yes
+Billboard Cloud Grouped Indirect Texturing Groups				1
 
-Billboard Cloud Grouped XML Name						mapleLeavesBillboardCloudGrouped.xml
-Billboard Cloud Grouped Mesh Name						mapleLeavesBillboardCloudGrouped.mesh
-Billboard Cloud Grouped Material Name						mapleLeavesBillboardCloudGroupMaterial
-Billboard Cloud Grouped Texture Unit 0 Name					mapleLeavesBillboardGroupTexture
+Billboard Cloud Grouped Diffuse Color XML Name					mapleLeavesBillboardCloudGroupedDiffuseColor.xml
+Billboard Cloud Grouped Diffuse Color Mesh Name					mapleLeavesBillboardCloudGroupedDiffuseColor.mesh
+Billboard Cloud Grouped Diffuse Color Material Name				mapleLeavesBillboardCloudGroupedDiffuseColorMaterial
+Billboard Cloud Grouped Diffuse Color Texture Unit 0 Name			mapleLeavesBillboardTexture
+
+Billboard Cloud Grouped Indirect Texturing XML Name				mapleLeavesBillboardCloudGroupedIndirectTexturing.xml
+Billboard Cloud Grouped Indirect Texturing Mesh Name				mapleLeavesBillboardCloudGroupedIndirectTexturing.mesh
+Billboard Cloud Grouped Indirect Texturing Material Name			mapleLeavesBillboardCloudGroupedIndirectTexturingMaterial
+Billboard Cloud Grouped Indirect Texturing Texture Unit 0 Name			mapleLeavesBillboardGroupTexture
 
 Billboard Cloud Splitted XML Name						mapleLeavesBillboardCloudSplitted.xml
@@ -57,24 +59,10 @@
 Billboard Cloud Indirect Point Material Name					billboardCloudIndirectPointMaterial
 
-Billboard Cloud Diffuse Color Merged Billboards Texture Atlas Generation	yes
-Billboard Cloud Diffuse Color Merged Billboards Texture Atlas Debug		no
-Billboard Cloud Diffuse Color Merged Billboards Texture Atlas Name		mapleMergedBillboardsDiffuseColorAtlas.png
-Billboard Cloud Diffuse Color Merged Billboards Texture Atlas Bit Range		8
-Billboard Cloud Diffuse Color Merged Billboards Texture Atlas Size		1024
-Billboard Cloud Diffuse Color Merged Billboards Texture Size			16
-
-Billboard Cloud Indirect Merged Billboards Texture Atlas Generation		yes
-Billboard Cloud Indirect Merged Billboards Texture Atlas Debug			no
-Billboard Cloud Indirect Merged Billboards Texture Atlas Name			mapleMergedBillboardsIndirectAtlas.png
-Billboard Cloud Indirect Merged Billboards Texture Atlas Bit Range		8
-Billboard Cloud Indirect Merged Billboards Texture Atlas Size			1024
-Billboard Cloud Indirect Merged Billboards Texture Size				16
-
 Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Generation	yes
 Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Debug		no  
 Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Name		mapleDiffuseColorBillboardGroupAtlas.png
 Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Bit Range	8
-Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Size		1024
-Billboard Cloud Diffuse Color Grouped Billboards Texture Size			16
+Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Size		2048
+Billboard Cloud Diffuse Color Grouped Billboards Texture Size			256
 
 Billboard Cloud Indirect Grouped Billboards Texture Atlas Generation		yes